package fr.natan.microservices.springsecurityserverjwt.moduleExceptions.exceptionHandler;

import fr.natan.microservices.springsecurityserverjwt.moduleExceptions.businessExceptions.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class AccountExceptionHandler {

    @ExceptionHandler(value = UserAccountAlreadyExistsException.class)
    private ResponseEntity<String> handleUserAccountAlreadyExistsException() {
        return new ResponseEntity<>("UserAccount Already Exists Exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = RoleAlreadyExistsException.class)
    private ResponseEntity<String> handleRoleAlreadyExistsException() {
        return new ResponseEntity<>("Role Already Exists Exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = UserAccountFieldsInvalidException.class)
    private ResponseEntity<String> handleUserAccountFieldsInvalidException() {
        return new ResponseEntity<>("UserAccount Fields' Values Invalid Exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = RoleFieldsInvalidException.class)
    private ResponseEntity<String> handleRoleFieldsInvalidException() {
        return new ResponseEntity<>("Role Fields' Values Invalid Exception",
                HttpStatus.NOT_ACCEPTABLE);
    }

    @ExceptionHandler(value = AppRoleNotFoundException.class)
    private ResponseEntity<String> handleAppRoleNotFoundException() {
        return new ResponseEntity<>("Role Not Found Exception",
                HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(value = UserAccountNotFoundException.class)
    private ResponseEntity<String> handleUserAccountNotFoundException() {
        return new ResponseEntity<>("User Account Not Found Exception",
                HttpStatus.NOT_FOUND);
    }

    @ExceptionHandler(value = UserAccountAlreadyAssignedThatRoleException.class)
    private ResponseEntity<String> handleUserAccountAlreadyAssignedThatRoleException() {
        return new ResponseEntity<>("UserAccount Already Assigned that Role Exception",
                HttpStatus.NOT_ACCEPTABLE);
    }
}
