package fr.natan.microservices.springsecurityserverjwt.service.services;

import fr.natan.microservices.springsecurityserverjwt.models.AppRole;
import fr.natan.microservices.springsecurityserverjwt.moduleExceptions.businessExceptions.*;
import fr.natan.microservices.springsecurityserverjwt.models.UserAccount;

import java.util.Collection;

public interface AccountService {
    UserAccount addNewUserAccount(UserAccount userAccount) throws UserAccountAlreadyExistsException,
            UserAccountFieldsInvalidException;
    UserAccount getUserByUsername(String username) throws UserAccountNotFoundException;
    Collection<UserAccount> loadAllUsers();
    Collection<AppRole> loadAllRoles();
    AppRole addNewRole(AppRole appRole) throws RoleAlreadyExistsException, RoleFieldsInvalidException;
    AppRole getRoleByRoleName(String  roleName) throws  AppRoleNotFoundException;
    void addRoleToUser(String username, String roleName) throws AppRoleNotFoundException, UserAccountNotFoundException,
            UserAccountAlreadyAssignedThatRoleException;
}

