package fr.natan.microservices.springsecurityserverjwt.t_authenticationFilter.a_userCreation;

import fr.natan.microservices.springsecurityserverjwt.models.AppRole;
import fr.natan.microservices.springsecurityserverjwt.models.UserAccount;
import fr.natan.microservices.springsecurityserverjwt.moduleExceptions.businessExceptions.UserAccountNotFoundException;
import fr.natan.microservices.springsecurityserverjwt.service.services.AccountService;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;

import java.util.ArrayList;
import java.util.Collection;

public class MyUserDetailsServiceImpl implements UserDetailsService {
    private final AccountService accountService;

    public MyUserDetailsServiceImpl(AccountService accountService) {
        this.accountService = accountService;
    }

    //création d'utilisateur spring pour s'authentifier
    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        UserAccount userAccount = null;
        try {
            userAccount = accountService.getUserByUsername(username);
        } catch (UserAccountNotFoundException e) {
            e.printStackTrace();
        }
        assert userAccount!=null;
        Collection<AppRole> appRoles = userAccount.getAppRoles();
        Collection<GrantedAuthority> grantedAuthorities = new ArrayList<>();
        for(AppRole appRole : appRoles){
            grantedAuthorities.add(new SimpleGrantedAuthority(appRole.getRoleName()));
        }

        return new User(userAccount.getUsername(), userAccount.getPwd(), grantedAuthorities);
    }
}
